function gmm_obj=cost_objective_function(tau,predicted_mcs,kagan_input_costs,channels_to_add_drop,deviation_market_share,bundle_market_shares,bundle_prices,match,vi_vector,X,mso_id,dma_order,use_bundle_moments,bootstrap_weights)
% disp(tau)
mc_Comcast=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*24 + tau(4)*vi_vector(:,1));
mc_TWC=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*12 + tau(4)*vi_vector(:,2));
mc_Cox=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*5 + tau(4)*vi_vector(:,3));
mc_Charter=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*5 + tau(4)*vi_vector(:,4));
mc_Cablevision=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*3 + tau(4)*vi_vector(:,5));
mc_Other=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*.05 + tau(4)*vi_vector(:,6));
mc_DirecTV=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*16 + tau(4)*vi_vector(:,7));
mc_Dish=(tau(1)+tau(2)*kagan_input_costs).*exp(tau(3)*14 + tau(4)*vi_vector(:,8));

% Linear specification- out of curiosity
% mc_Comcast=tau(1)+tau(2)*kagan_input_costs+ tau(3)*24 + tau(4)*vi_vector(:,1);
% mc_TWC=tau(1)+tau(2)*kagan_input_costs+ tau(3)*12 + tau(4)*vi_vector(:,2);
% mc_Cox=tau(1)+tau(2)*kagan_input_costs+ tau(3)*5 + tau(4)*vi_vector(:,3);
% mc_Charter=tau(1)+tau(2)*kagan_input_costs+ tau(3)*5 + tau(4)*vi_vector(:,4);
% mc_Cablevision=tau(1)+tau(2)*kagan_input_costs+ tau(3)*3 + tau(4)*vi_vector(:,5);
% mc_Other=tau(1)+tau(2)*kagan_input_costs+ tau(3)*.05 + tau(4)*vi_vector(:,6);
% mc_DirecTV=tau(1)+tau(2)*kagan_input_costs+ tau(3)*16 + tau(4)*vi_vector(:,7);
% mc_Dish=tau(1)+tau(2)*kagan_input_costs+ tau(3)*14 + tau(4)*vi_vector(:,8);


%computed implied bundle mc's
mc=zeros(length(X(:,1)),length(mc_Comcast));
mc_full=zeros(length(X(:,1)),length(mc_Comcast));
vi=zeros(length(X(:,1)),length(mc_Comcast));
for k=1:length(mc_Comcast)
mc(mso_id==1,k)=mc_Comcast(k).*X(mso_id==1,1+k);
mc(mso_id==2,k)=mc_TWC(k).*X(mso_id==2,1+k);
mc(mso_id==3,k)=mc_Cox(k).*X(mso_id==3,1+k);
mc(mso_id==4,k)=mc_Charter(k).*X(mso_id==4,1+k);
mc(mso_id==5,k)=mc_Cablevision(k).*X(mso_id==5,1+k);
mc(mso_id==6,k)=mc_Other(k).*X(mso_id==6,1+k);

mc_full(mso_id==1,k)=mc_Comcast(k).*X(mso_id==1,1);
mc_full(mso_id==2,k)=mc_TWC(k).*X(mso_id==2,1);
mc_full(mso_id==3,k)=mc_Cox(k).*X(mso_id==3,1);
mc_full(mso_id==4,k)=mc_Charter(k).*X(mso_id==4,1);
mc_full(mso_id==5,k)=mc_Cablevision(k).*X(mso_id==5,1);
mc_full(mso_id==6,k)=mc_Other(k).*X(mso_id==6,1);


vi(mso_id==1,k)=vi_vector(k,1).*X(mso_id==1,1+k);
vi(mso_id==2,k)=vi_vector(k,2).*X(mso_id==2,1+k);
vi(mso_id==3,k)=vi_vector(k,3).*X(mso_id==3,1+k);
vi(mso_id==4,k)=vi_vector(k,4).*X(mso_id==4,1+k);
vi(mso_id==5,k)=vi_vector(k,5).*X(mso_id==5,1+k);
vi(mso_id==6,k)=vi_vector(k,6).*X(mso_id==6,1+k);
end

mc_total=sum(mc,2);

%compute implied average costs

implied_ac=(24*mc_Comcast + 12*mc_TWC + 5*mc_Cox + 5*mc_Charter + 3*mc_Cablevision + 14*mc_Other + 16*mc_DirecTV + 14*mc_Dish)/(24+12+5+5+3+14+16+14);
moment_1=(implied_ac-kagan_input_costs);
   
    mso_size=mso_id;
    mso_size(mso_id==1)=24;
    mso_size(mso_id==2)=14;
    mso_size(mso_id==3)=5;
    mso_size(mso_id==4)=5;
    mso_size(mso_id==5)=3;
    mso_size(mso_id==6)=.05;
    
    ZZ=[ones(size(mso_size(dma_order(:,1)>2005))) mc(dma_order(:,1)>2005,:)];
    W=diag(bootstrap_weights(dma_order(:,1)>2005));
    b_hat=(ZZ'*W*ZZ)\(ZZ'*W*predicted_mcs(dma_order(:,1)>2005));
    R=predicted_mcs(dma_order(:,1)>2005)-ZZ*b_hat;
    
    %optimal pricing conditions
    moment_2=[((bootstrap_weights(dma_order(:,1)>2005).*mso_size(dma_order(:,1)>2005))'*R)./length(mso_size(dma_order(:,1)>2005)); ((bootstrap_weights(dma_order(:,1)>2005).*sum(vi(dma_order(:,1)>2005,:),2))'*R)./length(mso_size(dma_order(:,1)>2005))];
    
  %  moment_2=[(mso_size(dma_order(:,1)>2005)'*R)./length(mso_size(dma_order(:,1)>2005)); (sum(vi(dma_order(:,1)>2005,:),2)'*R)./length(mso_size(dma_order(:,1)>2005))];
    
        
    %optimal bundling conditions
        if (use_bundle_moments==1)
    profits = bundle_market_shares.*(bundle_prices-mc_total);
     deviation_profits=zeros(length(X(:,1)),length(channels_to_add_drop));
     delta_profits=zeros(length(X(:,1)),length(channels_to_add_drop));
     sum_profits=zeros(length(X(:,1)),length(channels_to_add_drop));
    for k=1:length(channels_to_add_drop)
        deviation_profits(:,k) = deviation_market_share(:,k).*( bundle_prices-mc_total + mc(:,k).*X(:,1+k) - mc(:,k).*(1-X(:,1+k)) );
        delta_profits(:,k) = profits-deviation_profits(:,k);
        sum_profits(:,k) = delta_profits(:,k)+delta_profits(match(:,k),k);
    end
    
        end
    
    if (use_bundle_moments==0)
    moment_3=zeros(length(channels_to_add_drop),1);
    else
     moment_3=min(0,mean(repmat(bootstrap_weights(dma_order(:,1)>2005),1,length(sum_profits(1,:))).*sum_profits(dma_order(:,1)>2005,:)))';
%     moment_3=mean(min(0,sum_profits(dma_order(:,1)>2005,:)))';
    end
    
%compute gmm objective function    
disp(mean(moment_1)) 
disp(mean(moment_2))
disp(mean(moment_3))
gmm_obj=[moment_1; moment_2; moment_3]';
 disp(gmm_obj*gmm_obj')
% disp([moment_1; moment_2; moment_3]'*[moment_1; moment_2; moment_3])
% gmm_obj=[moment_1; moment_2; moment_3]'*[moment_1; moment_2; moment_3];