% Full optimization



    
% Define a lower bound very close to 0, but positive so we don't do log(0)
theta_lbound = zeros(size(all_parameters));
theta_lbound(1:(number_of_channels+1)*((number_of_channels+1)-1)/2)=-1;
theta_lbound(end-number_of_channels+1:end)=0;
theta_lbound((u_length+1):(end-1))=0;
theta_lbound(end)=-1;

theta_ubound = 25*ones(size(all_parameters));
theta_ubound(1:(number_of_channels+1)*((number_of_channels+1)-1)/2)=1;
theta_ubound(end-number_of_channels+1:end)=25;
theta_ubound((u_length+1):(end-1))=1;
theta_ubound(end)=1;

full_objective_function(all_parameters(1),1,all_parameters,u_length,specification,market_demographics_draws,fast_zero_out_draws,fast_unobs_draws_matrix,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,dma_order,market_representative,simulations,same_market,sat_dma_rep,system_relative_dma_size,same_dma,homespassed_matrix,match_dmas,mean_demographics,actual_dma_ratings,mean_viewership_by_demographic,covariance_in_hh_viewership,demographic_cume,utility_demographics_matrices,deltas,mu_eps,income_matrix,mediamark_income_moments,bundle_prices,satellite_prices,same_market_min_max_index,same_dma_min_max_index,sys_size_vector,X_small,X_small_hat,bundle_market_shares,satellite_share,homespassed_share,1,cume_matrices,normalize,0);


if (univariate==1)
    
for zzz=1:number_of_channels

optimizing_indices=dummy_marginal_distribution_parameters(zzz);

fsearch_options=optimset('TolX',.0005,'TolFun',.0005,'MaxFunEvals',1000);

estimated_params=fminsearchcon(@(z) full_objective_function(z,optimizing_indices,all_parameters,u_length,specification,market_demographics_draws,fast_zero_out_draws,fast_unobs_draws_matrix,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,dma_order,market_representative,simulations,same_market,sat_dma_rep,system_relative_dma_size,same_dma,homespassed_matrix,match_dmas,mean_demographics,actual_dma_ratings,mean_viewership_by_demographic,covariance_in_hh_viewership,demographic_cume,utility_demographics_matrices,deltas,mu_eps,income_matrix,mediamark_income_moments,bundle_prices,satellite_prices,same_market_min_max_index,same_dma_min_max_index,sys_size_vector,X_small,X_small_hat,bundle_market_shares,satellite_share,homespassed_share,1,cume_matrices,normalize,0), all_parameters(optimizing_indices),  theta_lbound(optimizing_indices), theta_ubound(optimizing_indices),[],[],@(z) compute_eigenvalues(z,optimizing_indices,all_parameters,u_length,specification),fsearch_options);

all_parameters(optimizing_indices)=estimated_params;

save all_parameters all_parameters

end
            
elseif (channel_by_channel==1)

for zzz=1:(number_of_channels+1)

    if (zzz<=number_of_channels)
        if (estimate_copula_parameters==0)
        optimizing_indices=[dummy_marginal_distribution_parameters(zzz) dummy_Pi_matrix(zzz,:) dummy_rho(zzz,:)];
        elseif (estimate_copula_parameters==1)
        optimizing_indices=[dummy_marginal_distribution_parameters(zzz) dummy_Pi_matrix(zzz,:) dummy_copula_parameter(zzz,[1:(zzz-1) (zzz+1):(number_of_channels+1)]) dummy_rho(zzz,:)];
        end
    else
        optimizing_indices=[dummy_Pi_matrix(zzz,:) length(all_parameters)];
    end
    

%  optimizing_indices=[dummy_marginal_distribution_parameters(zzz) dummy_Pi_matrix(zzz,:) dummy_rho(zzz,:)];
fsearch_options=optimset('TolX',.0005,'TolFun',.0005,'MaxFunEvals',1000);

estimated_params=fminsearchcon(@(z) full_objective_function(z,optimizing_indices,all_parameters,u_length,specification,market_demographics_draws,fast_zero_out_draws,fast_unobs_draws_matrix,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,dma_order,market_representative,simulations,same_market,sat_dma_rep,system_relative_dma_size,same_dma,homespassed_matrix,match_dmas,mean_demographics,actual_dma_ratings,mean_viewership_by_demographic,covariance_in_hh_viewership,demographic_cume,utility_demographics_matrices,deltas,mu_eps,income_matrix,mediamark_income_moments,bundle_prices,satellite_prices,same_market_min_max_index,same_dma_min_max_index,sys_size_vector,X_small,X_small_hat,bundle_market_shares,satellite_share,homespassed_share,1,cume_matrices,normalize,0), all_parameters(optimizing_indices),  theta_lbound(optimizing_indices), theta_ubound(optimizing_indices),[],[],@(z) compute_eigenvalues(z,optimizing_indices,all_parameters,u_length,specification),fsearch_options);

all_parameters(optimizing_indices)=estimated_params;

save all_parameters all_parameters

end

end