function [predicted_shares predicted_satellite_shares]=market_shares(deltas,interactions,X,simulations,same_market)




v_ij=interactions{1};
v_ij_satellite=interactions{2};
outside_good_utility=interactions{5};
price_interactions=interactions{6};
price_interactions_satellite=interactions{7};

simulated_household=(price_interactions.*v_ij);
simulated_household_satellite=(price_interactions_satellite.*v_ij_satellite);


predicted_share_numerator=zeros(length(X(:,1)),simulations);
predicted_share_denominator_pre=zeros(length(X(:,1)),simulations);
satellite_deltas_matrix=zeros(length(X(:,1)),simulations);
    
        for k=1:simulations
            predicted_share_numerator(:,k)=min(10^299,deltas(:,1).*(simulated_household(:,k)));
            satellite_deltas_matrix(:,k)=min(10^299,deltas(:,2).*(simulated_household_satellite(:,k)));
            predicted_share_denominator_pre(:,k)=(satellite_deltas_matrix(:,k));
        end


predicted_share_denominator=(outside_good_utility + predicted_share_denominator_pre + same_market*predicted_share_numerator);
predicted_satellite_shares=satellite_deltas_matrix./predicted_share_denominator;
predicted_shares=predicted_share_numerator./predicted_share_denominator;
% 
% save elasticity_computations predicted_share_numerator satellite_deltas_matrix predicted_share_denominator deltas interactions X simulations same_market
