function [wtp_distribution utility beta_i mkt_demographics pre_gamma outside_good_utility] = sample_wtp(all_parameters,channel,bundle,mkt_demographics,sample_unobservable_draws,sample_zero_out_draws,specification,simulations)

bundle(channel)=1;

beta_p=-.44;

number_of_channels=sum(specification(:,3));
u_length=(number_of_channels+1)*((number_of_channels+1)-1)/2 + (number_of_channels+1)*7 + number_of_channels;

utility_parameters_vector=all_parameters(1:u_length);

pre_rho=all_parameters((u_length+1):(end-1));    
rho=reshape(pre_rho,number_of_channels+1,8);

alpha_i=all_parameters(end);


marginal_distribution_parameters=zeros(number_of_channels+1,1);
pi_index=((number_of_channels+1)*((number_of_channels+1)-1)/2+1);
Pi_matrix=reshape(utility_parameters_vector(pi_index:pi_index-1+(number_of_channels+1)*7),(number_of_channels+1),7);
marginal_distribution_parameters(1:end-1)=utility_parameters_vector(end-number_of_channels+1:end);
pre_copula_parameter=utility_parameters_vector(1:(number_of_channels+1)*((number_of_channels+1)-1)/2);
marginal_distribution_parameters(end)=5;

Pi_matrix=max(Pi_matrix,0);
marginal_distribution_parameters=max(marginal_distribution_parameters,0);

copula_parameter=zeros(number_of_channels+1,number_of_channels+1);
next=1;
for k=1:number_of_channels+1
   for j=1:k
    if (j~=k)
    copula_parameter(k,j)=pre_copula_parameter(next);
    next=next+1;
    end
   end
end
copula_parameter=copula_parameter+copula_parameter'+eye(number_of_channels+1);
%     copula_parameter=eye(number_of_channels+1);

% test_demographics=mean(demographics);
% [mkt_demographics sample_unobservable_draws sample_zero_out_draws]=set_random_draws_single_market(1,test_demographics,simulations,number_of_channels+1);

        rho_test=zeros(simulations,number_of_channels+1);
        rho_test(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)>=.5,:)=ones(sum(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)>=.5),1)*rho(:,1)';
        rho_test(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)>=.5,:)=ones(sum(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)>=.5),1)*rho(:,2)';
        rho_test(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)<.5,:)=ones(sum(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)<.5),1)*rho(:,3)';
        rho_test(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)<.5,:)=ones(sum(mkt_demographics(:,1)==1 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)<.5),1)*rho(:,4)';
        rho_test(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)>=.5,:)=ones(sum(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)>=.5),1)*rho(:,5)';
        rho_test(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)>=.5,:)=ones(sum(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)>=.5),1)*rho(:,6)';
        rho_test(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)<.5,:)=ones(sum(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==0 & mkt_demographics(:,7)<.5),1)*rho(:,7)';
        rho_test(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)<.5,:)=ones(sum(mkt_demographics(:,1)==0 & mkt_demographics(:,3)==1 & mkt_demographics(:,7)<.5),1)*rho(:,8)';
        
        zero_out_indicator = sample_zero_out_draws'< rho_test;   
        
        rand_draws=normcdf(copula_parameter*sample_unobservable_draws)';
        sim_ones=ones(1,simulations);
        unattributable_draws=(marginal_distribution_parameters*sim_ones).*(-log( rand_draws'));          
        unattributable_draws=unattributable_draws.*zero_out_indicator';
        
        pre_gamma=(Pi_matrix*mkt_demographics').*zero_out_indicator' + unattributable_draws;
        
         gamma_vector_with_channel=(bundle'*sim_ones).*pre_gamma;
         bundle_without_channel=bundle;
         bundle_without_channel(channel)=0;
         gamma_vector_without_channel=(bundle_without_channel'*sim_ones).*pre_gamma;
         
         bundle_total_gamma=0.0000001+sum( gamma_vector_with_channel);
         bundle_without_channel_total_gamma=0.0000001+sum( gamma_vector_without_channel);
         
         time_watched_with_channel=gamma_vector_with_channel./bundle_total_gamma(ones(number_of_channels+1,1),:);
         time_watched_without_channel=gamma_vector_without_channel./bundle_without_channel_total_gamma(ones(number_of_channels+1,1),:);
         
         v_ij=sum(pre_gamma.*log(1+(10080)*time_watched_with_channel));
         v_ij_without_channel=sum(pre_gamma.*log(1+(10080)*time_watched_without_channel));
                 
         utility=(v_ij-v_ij_without_channel)';
         wtp_distribution=((v_ij-v_ij_without_channel)'./-(min(-.05,beta_p+alpha_i*mkt_demographics(:,2))));
         
         beta_i=beta_p+alpha_i*mkt_demographics(:,2);
        
        