function f=bargaining_set_basic_parameters(constants_and_logit_var,last_prices,bundles,input_cost,regulation_option,preferences)

disp(constants_and_logit_var)

preferences{7}=constants_and_logit_var(end);
preferences{9}=constants_and_logit_var(1:end-1);

beta_i_big_market=preferences{1};
channels_utility_big_market=preferences{2};
pre_gamma_big_market=preferences{3};
beta_i_small_market=preferences{4};
channels_utility_small_market=preferences{5};
pre_gamma_small_market=preferences{6};
logit_var=preferences{7};
market_size=preferences{8};
utility_constants=preferences{9};
outside_good_utility=preferences{11};

[downstream_profits upstream_profits prices]=bargaining_downstream_equilibrium(last_prices,bundles,input_cost,regulation_option,preferences);

p1=prices(1);
p2=prices(2);
p3=prices(3);
p4=prices(4);

[player_profits downstream_profits market_share_big_market market_share_small_market upstream_fee_revenue]=bargaining_downstream_firm_profits_mex(1,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,1,utility_constants,outside_good_utility);

market_shares=[mean(market_share_big_market(:,1)) mean(market_share_small_market(:,1)) (mean(market_share_big_market(:,2:3))*market_size(1) + mean(market_share_small_market(:,2:3))*market_size(2))./sum(market_size) ];

disp([market_shares p1 p2 p3 p4])

f = [market_shares (.6*p1/100+.1*p2/100+.2*p3/100+.1*p4/100)] - [.57 .57 .18 .13 .32];
