function [predicted_mcs Pi_matrix marginal_distribution_parameters copula_parameter]=cost_preliminaries(deltas,utility_parameters_vector,rho,alpha_i,mu_eps,specification,dma_order,bundle_prices,satellite_prices,income_matrix,simulations,market_demographics_draws,fast_zero_out_draws,fast_unobs_draws_matrix,parametric_family_of_marginal_distributions,copula_parametric_family,X,market_representative,satellite_channels,same_market,same_market_min_max_index,beta_p,bundle_market_shares)


prices_matrix=bundle_prices*ones(1,simulations);
satellite_prices_vector=satellite_prices(-1996+dma_order(:,1));
prices_matrix_satellite=satellite_prices_vector*ones(1,simulations);
price_interactions=exp(mu_eps*alpha_i.*income_matrix.*prices_matrix);
price_interactions_satellite=exp(mu_eps*alpha_i.*income_matrix.*prices_matrix_satellite);

number_of_channels=sum(specification(:,3));
marginal_distribution_parameters=zeros(number_of_channels+1,1);

pi_index=((number_of_channels+1)*((number_of_channels+1)-1)/2+1);

Pi_matrix=reshape(utility_parameters_vector(pi_index:pi_index-1+(number_of_channels+1)*7),(number_of_channels+1),7);
marginal_distribution_parameters(1:end-1)=utility_parameters_vector(end-number_of_channels+1:end);
pre_copula_parameter=utility_parameters_vector(1:(number_of_channels+1)*((number_of_channels+1)-1)/2);
marginal_distribution_parameters(end)=5;

copula_parameter=zeros(number_of_channels+1,number_of_channels+1);
next=1;
for k=1:number_of_channels+1
   for j=1:k
    if (j~=k)
    copula_parameter(k,j)=pre_copula_parameter(next);
    next=next+1;
    end
   end
end

copula_parameter=copula_parameter+copula_parameter'+eye(number_of_channels+1);

simulations_vector=ones(1,simulations);
year_id=dma_order(:,1);
dma_id=dma_order(:,2);
market_id=dma_order(:,3);

[v_ij v_ij_satellite time_watched_cable time_watched_satellite outside_good_utility]=assemble_markets_fortran_mex(Pi_matrix,simulations_vector,marginal_distribution_parameters,rho,copula_parameter,market_demographics_draws,fast_zero_out_draws,fast_unobs_draws_matrix,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,market_representative,dma_id,market_id,year_id,mu_eps);
interactions={v_ij,v_ij_satellite,time_watched_cable,time_watched_satellite,outside_good_utility,price_interactions,price_interactions_satellite};


    [bundle_shares_by_household satellite_shares_by_household]=market_shares(deltas,interactions,X,simulations,same_market);
    
    [DELTA DELTA_i]=create_DELTA_matrix(alpha_i,income_matrix,bundle_shares_by_household,same_market_min_max_index,mu_eps);
    DELTA=sparse(DELTA);
    DELTA_i=sparse(DELTA_i);
    
        invert_DELTA=((DELTA.*(beta_p)+DELTA_i).*mu_eps);

        markup=invert_DELTA\bundle_market_shares;
        predicted_mcs = bundle_prices+markup;
        
        